/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fr.amap.lidar.amapvox.visualization.controllers.voxels;

import fr.amap.lidar.amapvox.visualization.controllers.loadables.textures.TextureCubemap;
import java.io.IOException;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Map;

/**
 *
 * @author Tristan Muller (tristan.muller@cirad.fr)
 */
public class Skyboxes {
    
    private static Map<String, TextureCubemap> SKIES = new LinkedHashMap();
    
    public static void initializeSkies() throws IOException {
        SKIES.put("Simple", new TextureCubemap(512, 512, 
                "/textures/simplesky/right.png", "/textures/simplesky/left.png", 
                "/textures/simplesky/top.png", "/textures/simplesky/bottom.png", 
                "/textures/simplesky/back.png", "/textures/simplesky/front.png"));
        
        SKIES.put("Plain", new TextureCubemap(512, 512, 
                "/textures/plainsky/right.png", "/textures/plainsky/left.png", 
                "/textures/plainsky/top.png", "/textures/plainsky/bottom.png", 
                "/textures/plainsky/back.png", "/textures/plainsky/front.png"));
        
        SKIES.put("Blizzard", new TextureCubemap(512, 512, 
                "/textures/blizzardsky/right.png", "/textures/blizzardsky/left.png", 
                "/textures/blizzardsky/top.png", "/textures/blizzardsky/bottom.png", 
                "/textures/blizzardsky/back.png", "/textures/blizzardsky/front.png"));
        
        SKIES.put("Sahara", new TextureCubemap(512, 512, 
                "/textures/saharasky/right.png", "/textures/saharasky/left.png", 
                "/textures/saharasky/top.png", "/textures/saharasky/bottom.png", 
                "/textures/saharasky/back.png", "/textures/saharasky/front.png"));
        
        SKIES.put("Miramar", new TextureCubemap(512, 512, 
                "/textures/miramarsky/right.png", "/textures/miramarsky/left.png", 
                "/textures/miramarsky/top.png", "/textures/miramarsky/bottom.png", 
                "/textures/miramarsky/back.png", "/textures/miramarsky/front.png"));
    }
    
    public static TextureCubemap getSky(final String name) {
        return SKIES.get(name);
    }
    
    public static String[] getSkyNames() {
        final String[] names = new String[SKIES.size()];
        
        final Iterator<String> iterator = SKIES.keySet().iterator();
        int index = 0;
        
        while(iterator.hasNext()) {
            names[index] = iterator.next();
            index++;
        }
        
        return names;
    }
    
}
